#include "ti86asm.inc"

;#####===== SOURCE CODE FOR HIGHWAY
;#####===== BY Jarno Lveri, 2000, Finland

;If you find any bugs or maybe a way to make this smaller,
;please email me at jlaaveri@hotmail.com

.org _asm_exec_ram

;########## prog start
 ld hl,$fe20					;I don't understand why I need this crap,
 ld (carpos),hl					;but program doesn't work correctly without
 ld hl,straight					;it
 ld (spriteaddr),hl
 ld a,1
 ld (ltraffic),a
 ld (rtraffic),a
 ld (slowdown),a
 inc a
 ld (way),a
 ld a,$21
 ld (way2),a
 ld a,64
 ld (setllane),a
 add a,a
 ld (setrlane),a
 ld hl,comcarsources
 ld de,leftcar
 ld bc,8
 ldir

titlescreen:
 call _clrScrn
 call _runindicoff

 ld bc,$0403
 ld (_curRow),bc
 ld hl,title
 call _puts

 set 3,(iy+5)
 ld bc,$2223
 ld (_penCol),bc
 call _vputs
 res 3,(iy+5)
 call _getkey
 cp kExit
 jp z,exit

 cp kF1
 jr nz,more1 
 xor a
 ld (slowdown),a
 ld hl,speedm
 jr cheat
more1:

 cp kDel
 jr nz,more2
 ld a,3
 ld (slowdown),a
 ld hl,ladam
 jr cheat
more2:

 cp kEE
 jr nz,start
 ld hl,ufo
 ld de,leftcar
 ld bc,8
 ldir
 ld hl,ufom

cheat:
 ld bc,$0602
 ld (_curRow),bc
 call _puts
 ld hl,modetxt
 call _puts 

 ld b,200
hl1:
 halt
 djnz hl1


;########## first screen
start:
 ld b,16	
build:
 push bc

 ld b,8					
buildscrl:				
 push bc
 ld hl,0
 ld c,64
 call scroll
 pop bc
 djnz buildscrl
 call makewalls

 pop bc
 djnz build 	

;=====draw "map"
 ld b,16
 ld hl,$fff0
 ld a,%10101010
road:
 ld (hl),a
 inc hl
 djnz road

 ld hl,$ffaf
 ld de,leftcar
 ld b,4
 call putwallsprite


;################################################
;======engine====================================
;################################################
mainloop:

;=====check if the way is clear or not
 ld a,(way2)
 ld b,a
 ld hl,(carpos)
 call inchl
 ld b,4
crashcheck:
 ld a,(hl)
 and %10000000
 jp nz,crash
 call s16ba
 djnz crashcheck

;=====draw your car
 ld de,(spriteaddr)
 ld hl,(carpos)
 ld b,8
dcloop:
 ld a,(de)
 or a
 jr z,dcjump
 ld (hl),a
dcjump:
 call s16ba
 inc de
 djnz dcloop

;=====check keyboard
 ld a,(btndelay)
 cp 0
 jr z,dokc
 dec a
 ld (btndelay),a 
 jr kcdone
dokc:
 call checkkeys
kcdone:

;=====scroll the left lane
 ld hl,$fda0 
 ld c,24
 call scroll


 ld a,(slowdown)
 or a
 jr z,nohalt
 cp 1
 jr z,normhalt 
 halt
 halt
normhalt:
 halt
nohalt:


;=====check ltraffic
 ld a,(ltraffic)
 dec a
 ld (ltraffic),a
 cp 0
 jr nz,leftdone
;=====draw car on left lane
 ld hl,leftcar
 ld (whichcomcar),hl
 ld hl,$fbdf
 ld (whichlane),hl
 ld hl,llplus 
 call comcars
 ld a,(setllane)
 ld (ltraffic),a
leftdone:

;=====check rtraffic
 ld a,(rtraffic)
 dec a
 ld (rtraffic),a
 cp 0
 jr nz,rightdone
;=====draw car on right lane
 ld hl,rightcar
 ld (whichcomcar),hl
 ld hl,$fd5f
 ld (whichlane),hl
 ld hl,rlplus 
 call comcars
 ld a,(setrlane)
 ld (rtraffic),a

rightdone:
 ld a,(l4mem)
 dec a
 ld (l4mem),a
 jp nz,mainloop
;#####========== 2
 ld a,2
 ld (l4mem),a

;=====scroll road edges
 ld hl,$fc20
 ld c,2
 call scroll 
 ld hl,$ff80
 ld c,6
 call scroll

 ld a,(l3mem)
 dec a
 ld (l3mem),a
 jp nz,mainloop
;#####========== 4
 ld a,2
 ld (l3mem),a


;=====scroll right lane
 ld hl,$ff20
 ld c,25
 call scroll

 ld a,(l2mem)
 dec a
 ld (l2mem),a
 jp nz,mainloop
;#####========== 8
 ld a,2
 ld (l2mem),a


;=====check if 'exit' is pressed
 ld a,%111111
 out (1),a
 nop
 nop
 in a,(1)
 bit 6,a
 jp z,exit

;=====draw road edges
 call makewalls

;=====move car if way=0 or way=4
 ld b,$10
 ld hl,(carpos)
 ld a,(way)
 cp 0
 jr z,carposzero
 cp 4
 jr z,carposfour
 jr done_mch
carposzero:
 call dechl
 jr done_mch
carposfour:
 call inchl
done_mch:
 ld (carpos),hl	

 ld a,(l1mem)
 dec a
 ld (l1mem),a
 jp nz,mainloop
;#####========== 16
 ld a,2
 ld (l1mem),a

;=====move car if way=1 or way=3
 ld b,$10
 ld hl,(carpos)
 ld a,(way)
 cp 1
 jr z,carposone
 cp 3
 jr z,carposthree
 jr done_mce
carposone:
 call dechl
 jr done_mce
carposthree:
 call inchl 
done_mce:
 ld (carpos),hl

 ld a,(l0mem)
 dec a
 ld (l0mem),a
 jp nz,mainloop
;#####========== xxx
 ld a,22
 ld (l0mem),a

 ld b,2
udm: 
 push bc
 ld hl,$ffe0
 ld c,4
 call scroll
 pop bc
 djnz udm

;=====more traffic, please
 ld a,(setllane)
 dec a
 ld (setllane),a
 add a,a
 ld (setrlane),a

;=====draw a milestone
 ld de,milestone
 ld b,4
 ld hl,$ff4f
 call putwallsprite

 jp mainloop
;################################################
;========end of the engine=======================
;################################################










;########## call-instructios
crash:
 call _getkey
 cp kEnter
 jr nz,crash
exit:
 call _clrScrn
 jp _homeup

;=====
makewalls:
 ld de,wall
 ld hl,$fc0f
 ld b,2
 call putwallsprite
 ld de,wall
 ld hl,$ff2f
 ld b,2
 call putwallsprite
 ret

;=====
checkkeys:
 ld a,%11111110
 out (1),a
 in a,(1)
 bit 3,a
 jr z,turnup
 bit 0,a
 ret nz

;=====
turndown:
 ld a,(way)
 cp 4
 ret z
 inc a
 ld (way),a
 ld hl,(spriteaddr)
 ld b,8
 call dechl
 ld (spriteaddr),hl
 ld a,(way2)
 ld b,$10
 add a,b
 ld (way2),a
 ld a,8
 ld (btndelay),a
 ret
 
;=====
turnup:
 ld a,(way)
 cp 0						;or a??? (testaa........)
 ret z
 dec a
 ld (way),a
 ld hl,(spriteaddr)
 ld b,8
 call inchl
 ld (spriteaddr),hl
 ld a,(way2)
 ld b,$10
 sub b
 ld (way2),a
 ld a,8
 ld (btndelay),a
 ret

;=====
putwallsprite:	
 ld a,(de)
 ld (hl),a
 call s16ba
 inc de
 djnz putwallsprite
 ret

;=====
s16ba:
 ld a,16
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ret

;=====
inchl:
 inc hl
 djnz inchl
 ret

;=====
dechl:
 dec hl
 djnz dechl
 ret

;=====
scroll:
 ld b,4
 or a 
scroll2: 
 dec hl 
 rl (hl) 
 dec hl 
 rl (hl) 
 dec hl 
 rl (hl) 
 dec hl 
 rl (hl) 
 djnz scroll2 

 dec c 
 jr nz,scroll 
 ret

;=====
comcars:
 ld a,(hl)				;hl = rlplus/llplus, 1.byte
 dec a
 jr nz,ranstart
 ld a,4
 ld (hl),a
 inc hl					;hl = rlplus/llplus, 2.byte
 ld a,(hl)
 inc a
 and %11
 ld (hl),a
 ld b,a	
 jr yesran
ranstart:
 ld (hl),a				;hl = rlplus/llplus, 1.byte 
 ld a,r
 rra
 and %11
 ld b,a
 inc hl					;hl = rlplus/llplus, 2.byte
 inc hl					;hl = ranmem
 ld a,(hl)
 and %11
 cp b
 jr nz,noran
 ld a,(hl)
 rlca
 rlca 
 and %11
 ld b,a
 jr yesran
noran:
 ld a,(hl)
 sla a
 sla a
 or b
 ld (hl),a 
yesran:
 inc b
 ld hl,(whichlane)
 ld de,$60
findlane: 
 add hl,de
 djnz findlane
 ld de,(whichcomcar)
 ld b,4
 call putwallsprite
 ret


;########## variables
carpos:
.dw $fe20
spriteaddr:
.dw straight
way:
.db 2
way2:
.db $21
rightlanedelay:
.db 1
whichcomcar:
.dw 0
whichlane:
.dw 0
ltraffic
.db 1
setllane:
.db 64
rtraffic:
.db 1
setrlane:
.db 128
btndelay:
.db 1
l4mem:
.db 1
l3mem:
.db 1
l2mem:
.db 1
l1mem:
.db 1
l0mem:
.db 1
slowdown:
.db 0

title:
.db "H I G H W A Y",0
.db " by Jarno Laaveri ",0

speedm:
.db "speed",0
ladam:
.db "lada",0
ufom:
.db "ufo",0
modetxt:
.db " mode",0

;########## lane info
;=====left
llplus:
.db 8,3
lranmem:
.db 0

;=====right
rlplus:
.db 4,3
rranmem:
.db 0


;########## sprites
hardright:
.db 0
.db %00011000
.db %00110100
.db %01101110
.db %00111101
.db %00011001
.db %00001111
.db %00000110

easyright:
.db 0
.db %00100000
.db %01111000
.db %11011110
.db %10111001
.db %01110011
.db %00011110
.db 0

straight:
.db 0
.db 0
.db %01111110
.db %01011001
.db %01011001
.db %01111110
.db 0
.db 0

easyleft:
.db 0
.db %00001110
.db %01110011
.db %10111001
.db %11011110
.db %01111000
.db %00100000
.db 0

hardleft:
.db %00000110
.db %00001111
.db %00011001
.db %00111101
.db %01101110
.db %00110100
.db %00011000
.db 0

wall:
.db %11001100
.db %11001100

milestone:
.db %00001111
.db %00001011
.db %00001101
.db %00001111

leftcar:
.db %01111110
.db %10011010
.db %10011010
.db %01111110
rightcar:
.db %11111100
.db %10110010
.db %10110010
.db %11111100

ufo:
.db %00111000
.db %01000100
.db %01000100
.db %00111000
.db %00011100
.db %00100010
.db %00100010
.db %00011100

comcarsources:
.db %01111110
.db %10011010
.db %10011010
.db %01111110
.db %11111100
.db %10110010
.db %10110010
.db %11111100

.end
